## vmatch 2.3.1%2Bdfsg

=== src/Makefile ===
SYSTEM:=$(shell uname -s)
MACHINE:=$(shell uname -m)
ifeq ($(64bit),yes)
  BIT=64bit
else
  BIT=32bit
endif
VERSION:="`cat $(CURDIR)/VERSION`"
SYSTEMNAME:="$(SYSTEM)_$(MACHINE)"
VMATCHDISTBASENAME:="vmatch-$(VERSION)-$(SYSTEMNAME)-$(BIT)"
DISTDIR:="$(CURDIR)/dist/$(SYSTEMNAME)"
VMATCHDISTDIR:="$(DISTDIR)/$(VMATCHDISTBASENAME)"

SELECTDIR=SELECT
SMAPDIR=TRANS
INSTALLDIR=${DIRVSTREE}
INSTALLINCLUDE=${INSTALLDIR}/include
INSTALLSHARE=${INSTALLDIR}/share
INSTALLDOC=${INSTALLSHARE}/doc
INSTALLBIN=${WORK}/bin-ops/${CONFIGGUESS}
INSTALLDVLBIN=${INSTALLSHARE}/dvlbin
# the commands to use to install binaries, directories and data
# files respectively (data files meaning anything, which is not a binary
# file or directory)
# INSTALL_CMD_BIN=install -m 755
INSTALL_CMD_BIN=cp
INSTALL_CMD_DIR=install -d
# INSTALL_CMD_DATA=install -m 644
INSTALL_CMD_DATA=cp

INSTALLLIST=Mkvtree/mkvtree.x\
	    Mkvtree/vseqinfo.x\
	    Mkvtree/vseqselect.x\
	    Mkvtree/vsubseqselect.x\
	    Mkvtree/vendian.x\
	    Mkvtree/vstree2tex.x\
	    Mkvtree/mkdna6idx.x\
	    Mkvtree/mkrcidx.x\
	    Mkvtree/mkcfr.x\
	    Mkvtree/mkcld.x\
	    Mkvtree/mkiso.x\
	    Mkvtree/mklsf.x\
	    Mkvtree/mksti.x\
	    Vmatch/vmatch.x\
	    Vmatch/vmatchselect.x\
	    Vmatch/matchcluster.x\
	    Vmatch/chain2dim.x

all:
	${MAKE} -C kurtz-basic
	${MAKE} -C kurtz licensemanager=${licensemanager}
	${MAKE} -C Mkvtree licensemanager=${licensemanager}
	${MAKE} -C Vmengine
	${MAKE} -C Vmatch licensemanager=${licensemanager}

release:
	git tag "v`cat VERSION`"
	git push --tags origin master

libs:
	${MAKE} -C kurtz-basic
	${MAKE} -C kurtz
	${MAKE} -C Vmengine
	${MAKE} -C kurtz/libtest

vmatch:libs
	${MAKE} -C kurtz/libtest
	${MAKE} -C Mkvtree licensemanager=${licensemanager}
	${MAKE} -C Vmatch licensemanager=${licensemanager}

cleanup:
	find . -name '*.[oa]' | xargs rm -f

splintall:
	${MAKE} -C kurtz-basic splintall
	${MAKE} -C kurtz splintall
	${MAKE} -C Mkvtree splintall
	${MAKE} -C Vmengine splintall
	${MAKE} -C Vmatch splintall

splintclean:
	${MAKE} -C kurtz-basic splintclean
	${MAKE} -C kurtz splintclean
	${MAKE} -C Mkvtree splintclean
	${MAKE} -C Vmengine splintclean
	${MAKE} -C Vmatch splintclean

clean:
	${MAKE} -C Mkvtree clean cleanpp
	${MAKE} -C Vmengine clean
	${MAKE} -C Vmatch clean cleanpp
	${MAKE} -C kurtz-basic clean
	${MAKE} -C kurtz clean
	${MAKE} -C kurtz/libtest clean

cleanbuild:
	${MAKE} -C Mkvtree cleanbuild clean
	${MAKE} -C Vmatch cleanbuild clean
	${MAKE} -C kurtz cleanbuild clean
	${MAKE} -C kurtz-basic cleanbuild clean
	${MAKE} -C Vmengine cleanbuild clean

kurtz-basic.tar.gz:
	tar -cvf kurtz-basic.tar Makedef Makefile include lib kurtz-basic
	gzip -9 kurtz-basic.tar

cleanpp:
	${MAKE} -C Mkvtree cleanpp
	${MAKE} -C Vmatch cleanpp

install:
	bininstall.sh ${INSTALLLIST}
	${INSTALL_CMD_BIN} bin/cleanmkv.sh ${INSTALLBIN}/.
	${INSTALL_CMD_BIN} bin/cleanpp.sh ${INSTALLBIN}/.
	${INSTALL_CMD_BIN} bin/vmigrate.sh ${INSTALLBIN}/.
	${INSTALL_CMD_BIN} Emulate/repfind.pl ${INSTALLBIN}/.
	test -d ${INSTALLBIN}/SELECT || ${INSTALL_CMD_DIR} ${INSTALLBIN}/SELECT
	${INSTALL_CMD_DATA} Vmatch/SELECT/*.[ch] ${INSTALLBIN}/SELECT
	${INSTALL_CMD_DATA} Vmatch/SELECT/makefile ${INSTALLBIN}/SELECT
	${INSTALL_CMD_DATA} Vmatch/SELECT/Shareddef ${INSTALLBIN}/SELECT
	chmod ug+rx ${INSTALLBIN}/*.sh

srcinstall:
	mkdir -p ${INSTALLINCLUDE}
	mkdir -p ${INSTALLDOC}
	mkdir -p ${INSTALLDVLBIN}
	test -d ${INSTALLINCLUDE} || ${INSTALL_CMD_DIR} ${INSTALLINCLUDE}
	${INSTALL_CMD_DATA} include/*.[hc] include/*.pr ${INSTALLINCLUDE}
	${INSTALL_CMD_DATA} Vmatch/*.h ${INSTALLINCLUDE}
	${INSTALL_CMD_DATA} Vmengine/*.h ${INSTALLINCLUDE}
	libinstall.sh `grep '^PATHEND=' Makedef | sed 's/^PATHEND=//'`
	test -d ${INSTALLDOC} || ${INSTALL_CMD_DIR} ${INSTALLDOC}
	-${INSTALL_CMD_DATA} doc/virtman.pdf ${INSTALLDOC}
	-${INSTALL_CMD_DATA} doc/mkvtreeman.pdf ${INSTALLDOC}
	-${INSTALL_CMD_DATA} doc/multimat.pdf ${INSTALLDOC}
	-${INSTALL_CMD_DATA} doc/chain2dim.pdf ${INSTALLDOC}
	-${INSTALL_CMD_DATA} doc/matchcluster.pdf ${INSTALLDOC}
	-${INSTALL_CMD_DATA} doc/tallymer.pdf ${INSTALLDOC}
	-chmod ug+r ${INSTALLDOC}/*
	-test -d ${INSTALLDVLBIN} || ${INSTALL_CMD_DIR} ${INSTALLDVLBIN}
	-${INSTALL_CMD_DATA} bin/*.sh ${INSTALLDVLBIN}
	-chmod -f ug+r ${INSTALLDVLBIN}/*

check:
	cd Mkvtree; make check; cd ..
	cd Vmatch; make check; cd ..
	
.PHONY:SELECT
SELECT:
	${MAKE} -C Vmatch SELECT

STRIP:=strip

dist: SELECT
	@echo "[build distribution]"
	@rm -rf $(VMATCHDISTDIR)
	@mkdir -p $(VMATCHDISTDIR)
	@cp bin/vmigrate.sh $(VMATCHDISTDIR)
	@cp Emulate/repfind.pl $(VMATCHDISTDIR)
	@cp Mkvtree/upgradeprj.pl $(VMATCHDISTDIR)
ifeq ($(SYSTEM),Windows)
	@cp Mkvtree/mkvtree.x $(VMATCHDISTDIR)/mkvtree.exe
	@cp Mkvtree/vseqinfo.x $(VMATCHDISTDIR)/vseqinfo.exe
	@cp Mkvtree/vseqselect.x $(VMATCHDISTDIR)/vseqselect.exe
	@cp Mkvtree/vsubseqselect.x $(VMATCHDISTDIR)/vsubseqselect.exe
	@cp Mkvtree/vendian.x $(VMATCHDISTDIR)/vendian.exe
	@cp Mkvtree/vstree2tex.x $(VMATCHDISTDIR)/vstree2tex.exe
	@cp Mkvtree/mkdna6idx.x $(VMATCHDISTDIR)/mkdna6idx.exe
	@cp Vmatch/vmatch.x $(VMATCHDISTDIR)/vmatch.exe
	@cp Vmatch/vmatchselect.x $(VMATCHDISTDIR)/vmatchselect.exe
	@cp Vmatch/matchcluster.x $(VMATCHDISTDIR)/matchcluster.exe
	@cp Vmatch/chain2dim.x $(VMATCHDISTDIR)/chain2dim.exe
else
	@cp Mkvtree/mkvtree.x $(VMATCHDISTDIR)/mkvtree
	@cp Mkvtree/vseqinfo.x $(VMATCHDISTDIR)/vseqinfo
	@cp Mkvtree/vseqselect.x $(VMATCHDISTDIR)/vseqselect
	@cp Mkvtree/vsubseqselect.x $(VMATCHDISTDIR)/vsubseqselect
	@cp Mkvtree/vendian.x $(VMATCHDISTDIR)/vendian
	@cp Mkvtree/vstree2tex.x $(VMATCHDISTDIR)/vstree2tex
	@cp Mkvtree/mkdna6idx.x $(VMATCHDISTDIR)/mkdna6idx
	@cp Vmatch/vmatch.x $(VMATCHDISTDIR)/vmatch
	@cp Vmatch/vmatchselect.x $(VMATCHDISTDIR)/vmatchselect
	@cp Vmatch/matchcluster.x $(VMATCHDISTDIR)/matchcluster
	@cp Vmatch/chain2dim.x $(VMATCHDISTDIR)/chain2dim
endif
	@mkdir $(VMATCHDISTDIR)/${SMAPDIR}
	@cp Mkvtree/TRANS/Trans* $(VMATCHDISTDIR)/${SMAPDIR}
	@cp bin/cleanpp.sh $(VMATCHDISTDIR)
	@cp bin/Vmatchtrans.pl $(VMATCHDISTDIR)
	@cp doc/virtman.pdf $(VMATCHDISTDIR)
	@cp doc/chain2dim.pdf $(VMATCHDISTDIR)
	@cp doc/matchcluster.pdf $(VMATCHDISTDIR)
	@cp ../LICENSE $(VMATCHDISTDIR)
	@cp README.distrib $(VMATCHDISTDIR)
	@cp CHANGELOG $(VMATCHDISTDIR)
	@mkdir $(VMATCHDISTDIR)/${SELECTDIR}
	@checkforSELECTheaders.sh
	@cp Vmatch/SELECT/makefile $(VMATCHDISTDIR)/${SELECTDIR}
	@cp Vmatch/SELECT/*.[ch] $(VMATCHDISTDIR)/${SELECTDIR}
	@cp Vmatch/SELECT/Shareddef $(VMATCHDISTDIR)/${SELECTDIR}
ifeq ($(SYSTEM),Windows)
	@$(STRIP) $(VMATCHDISTDIR)/chain2dim.exe
	@$(STRIP) $(VMATCHDISTDIR)/matchcluster.exe
	@$(STRIP) $(VMATCHDISTDIR)/mkdna6idx.exe
	@$(STRIP) $(VMATCHDISTDIR)/mkvtree.exe
	@$(STRIP) $(VMATCHDISTDIR)/vendian.exe
	@$(STRIP) $(VMATCHDISTDIR)/vmatch.exe
	@$(STRIP) $(VMATCHDISTDIR)/vmatchselect.exe
	@$(STRIP) $(VMATCHDISTDIR)/vseqinfo.exe
	@$(STRIP) $(VMATCHDISTDIR)/vseqselect.exe
	@$(STRIP) $(VMATCHDISTDIR)/vstree2tex.exe
	@$(STRIP) $(VMATCHDISTDIR)/vsubseqselect.exe
else
	@$(STRIP) $(VMATCHDISTDIR)/chain2dim
	@$(STRIP) $(VMATCHDISTDIR)/matchcluster
	@$(STRIP) $(VMATCHDISTDIR)/mkdna6idx
	@$(STRIP) $(VMATCHDISTDIR)/mkvtree
	@$(STRIP) $(VMATCHDISTDIR)/vendian
	@$(STRIP) $(VMATCHDISTDIR)/vmatch
	@$(STRIP) $(VMATCHDISTDIR)/vmatchselect
	@$(STRIP) $(VMATCHDISTDIR)/vseqinfo
	@$(STRIP) $(VMATCHDISTDIR)/vseqselect
	@$(STRIP) $(VMATCHDISTDIR)/vstree2tex
	@$(STRIP) $(VMATCHDISTDIR)/vsubseqselect
endif
ifeq ($(SYSTEM),Windows)
	@cd $(DISTDIR) && 7z a -tzip $(VMATCHDISTBASENAME).zip $(VMATCHDISTBASENAME)
	@echo "$(DISTDIR)/$(VMATCHDISTBASENAME).zip"
else
	@cd $(DISTDIR) && tar --numeric-owner -cf $(VMATCHDISTBASENAME).tar $(VMATCHDISTBASENAME)
	@cd $(DISTDIR) && gzip -f -9 $(VMATCHDISTBASENAME).tar
	@echo "$(DISTDIR)/$(VMATCHDISTBASENAME).tar.gz"
endif

=== src/doc/mktab/Makefile ===
clean:
	rm -f data vm.tmp.* mkv[12].tmp.* format1

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
https://github.com/genometools/vstree/releases .*/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)

## vmatch 2.3.1%2Bgit20240412.b3b8ac0%2Bdfsg

=== src/doc/libdoc/Makefile ===
LATEX=latex
clean:
	rm -f *.inc *.aux *.dvi *.log *.ps *.idx *.blg *.bbl
	rm -f *.ilg *.ind *.toc *.out
	rm -f Ispell.tmp

Cfiles.dvi:Cfiles.ind
	Geninc.sh
	$LATEX Cfiles.tex

Cfiles.ind:Cfiles.idx
	makeindex -q Cfiles.idx -o $@

Ispell:
	cat ../*.c ../../include/*.h | c2lit.x | grep -v '^>' > Ispell.tmp

=== debian/control ===
Source: vmatch
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Sascha Steinbiss <satta@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               genometools,
               libgenometools0-dev,
               zlib1g-dev,
               libbz2-dev,
               asciidoctor
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/vmatch
Vcs-Git: https://salsa.debian.org/med-team/vmatch.git
Homepage: http://www.vmatch.de
Rules-Requires-Root: no

Package: vmatch
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: large scale sequence analysis software
 Vmatch is a versatile software tool for eﬃciently solving large scale
 sequence matching tasks. It subsumes the software tool REPuter, but is
 much more general, with a very ﬂexible user interface, and improved space
 and time requirements.

Package: libvmatch-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: development headers and static library for Vmatch
 This package contains C development headers and a static library to
 build custom programs and selector functions utilizing Vmatch.
 It also includes example source code for selector functions.

## vmatch 2.3.1+dfsg

=== src/Mkvtree/Makefile ===
include ../Makedef

MAINFLAGS=-DWITHLCP # ${DEFINESUFFIXPTR}
CFLAGS=${DEFINECFLAGS} ${DEFINECPPFLAGS} ${MAINFLAGS}
SPLINTFLAGS=${MAINFLAGS} ${DEFINESPLINTFLAGS}
VPATH=${COMPILEDIRPREFIX}
LDFLAGS=-L${COMPILEDIRPREFIX} ${DEFINELDFLAGS}
LDLIBS=${DEFINELDLIBS}
COMPILEDIR=${COMPILEDIRPREFIX}/Mkvtree/
#EXECDIR=${EXECDIRPREFIX}/Mkvtree/

ifneq ($(licensemanager),no)
  CFLAGS += -I../../../licensemanager/src \
            -I../../../genometools/src
  LDLIBS = ${CURDIR}/../../../licensemanager/lib/$(BIT)/liblicensemanager.a \
           ${CURDIR}/../../../genometools/lib/libgenometools.a \
           ${DEFINELDLIBS}
else
  CFLAGS += -DNOLICENSEMANAGER
  LDLIBS = ${CURDIR}/../../../genometools/lib/libgenometools.a \
           ${DEFINELDLIBS}
endif

MKVTREEOBJ=${COMPILEDIR}mkvtree.o\
           ${COMPILEDIR}mkvprocess.o\
           ${COMPILEDIR}bese.o\
           ${COMPILEDIR}besespecial.o\
           ${COMPILEDIR}ppsort.o\
           ${COMPILEDIR}mkvinput.o\
           ${COMPILEDIR}cprsuf.o\
           ${COMPILEDIR}remainsort.o

MKVTREEDBGOBJ=${COMPILEDIR}mkvtree.dbg.o\
              ${COMPILEDIR}mkvprocess.dbg.o\
              ${COMPILEDIR}bese.dbg.o\
              ${COMPILEDIR}besespecial.dbg.o\
              ${COMPILEDIR}ppsort.dbg.o\
              ${COMPILEDIR}mkvinput.dbg.o\
              ${COMPILEDIR}cprsuf.dbg.o\
              ${COMPILEDIR}remainsort.dbg.o

# add mkcfr.splint

EXPORTPROGS=${EXECDIR}mkvtree.x\
            ${EXECDIR}mkrcidx.x\
            ${EXECDIR}mkdna6idx.x\
            ${EXECDIR}mkcfr.x\
            ${EXECDIR}mklsf.x\
            ${EXECDIR}mkcld.x\
            ${EXECDIR}mksti.x\
            ${EXECDIR}mkiso.x\
            ${EXECDIR}vseqinfo.x\
            ${EXECDIR}vsubseqselect.x\
            ${EXECDIR}vendian.x\
            ${EXECDIR}vstree2tex.x\
            ${EXECDIR}vseqselect.x

LIBS=${LIBMKVTREE}\
     ${LIBKURTZ}\
     ${LIBKURTZBASIC}

LIBSDBG=${LIBMKVTREEDBG}\
        ${LIBKURTZDBG}\
        ${LIBKURTZBASICDBG}

.SUFFIXES: .dbg.o .c .o .pr

all:mkdircompiledir\
    ${EXPORTPROGS}\
    ${EXECDIR}allwhatsthere.x\
    ${EXECDIR}mapcfrcrf.x\
    ${EXECDIR}mkvram.x\
    ${EXECDIR}mkvcmp.dbg.x\
    ${EXECDIR}allwhatsthere.dbg.x\
    ${EXECDIR}mkrcidx.dbg.x\
    ${EXECDIR}mkdna6idx.dbg.x\
    ${EXECDIR}mkvtree.dbg.x

check:
	env -i MKVTREESMAPDIR=./TRANS ./Checkall.sh
	env -i ../bin/cleanpp.sh

bin:${EXPORTPROGS}
	cp ${EXPORTPROGS} ${BINDIRROOT}/`binarypath.sh mkvtree.x`

libs:${LIBMKVTREE} ${LIBMKVTREEDBG}

# the following programs are part of the mkvtree/vmatch distribution

${EXECDIR}mkvtree.x:${COMPILEDIR}mkvfile.o ${LIBS}
	${LD} ${LDFLAGS} ${COMPILEDIR}mkvfile.o ${LIBS} ${LDLIBS} -o $@

${EXECDIR}mkvtree.dbg.x:${COMPILEDIR}mkvfile.dbg.o ${LIBSDBG}
	${LD} ${LDFLAGS} ${COMPILEDIR}mkvfile.dbg.o ${LIBSDBG} ${LDLIBS} -o $@

${EXECDIR}vendian.x:${COMPILEDIR}endian.o
	${LD} ${LDFLAGS} ${COMPILEDIR}endian.o -o $@

${EXECDIR}vseqinfo.x:${COMPILEDIR}vseqinfo.o ${LIBKURTZBASIC}
	${LD} ${LDFLAGS} ${COMPILEDIR}vseqinfo.o ${LIBKURTZBASIC} ${LDLIBS} -o $@

${EXECDIR}vseqselect.x:${COMPILEDIR}vseqselect.o ${LIBKURTZ} ${LIBKURTZBASIC}
	${LD} ${LDFLAGS} ${COMPILEDIR}vseqselect.o ${LIBKURTZ} ${LIBKURTZBASIC} ${LDLIBS} -o $@

${EXECDIR}vsubseqselect.x:${COMPILEDIR}vsubseqselect.o \
                          ${LIBKURTZ}\
                          ${LIBKURTZBASIC}
	${LD} ${LDFLAGS} ${COMPILEDIR}vsubseqselect.o\
                         ${LIBKURTZ} ${LIBKURTZBASIC} ${LDLIBS} -o $@

${EXECDIR}vstree2tex.x:${COMPILEDIR}vstree2tex.o ${LIBKURTZ} ${LIBKURTZBASIC}
	${LD} ${LDFLAGS} ${COMPILEDIR}vstree2tex.o ${LIBKURTZ} ${LIBKURTZBASIC} ${LDLIBS} -o $@

${EXECDIR}allwhatsthere.x:${COMPILEDIR}allwhatsthere.o\
                          ${LIBKURTZBASIC}
	${LD} ${LDFLAGS} ${COMPILEDIR}allwhatsthere.o\
              ${LIBKURTZBASIC} ${LDLIBS} -o $@

${EXECDIR}allwhatsthere.dbg.x:${COMPILEDIR}allwhatsthere.dbg.o ${LIBKURTZBASICDBG}
	${LD} ${LDFLAGS} ${COMPILEDIR}allwhatsthere.dbg.o\
              ${LIBKURTZBASICDBG} ${LDLIBS} -o $@

# the following programs are used to generate some extra table

${EXECDIR}mkvcmp.dbg.x:${COMPILEDIR}mkvcmp.dbg.o ${LIBSDBG}
	${LD} ${LDFLAGS} ${COMPILEDIR}mkvcmp.dbg.o ${LIBSDBG} ${LDLIBS} -o $@

${EXECDIR}mkcfr.x:${COMPILEDIR}mkcfr.o\
                  ${LIBKURTZ}\
                  ${LIBKURTZBASIC}
	${LD} ${LDFLAGS} ${COMPILEDIR}mkcfr.o\
              ${LIBKURTZ} ${LIBKURTZBASIC} ${LDLIBS} -o $@

${EXECDIR}mksti.x:${COMPILEDIR}mksti.o ${LIBKURTZ} ${LIBKURTZBASIC}
	${LD} ${LDFLAGS} ${COMPILEDIR}mksti.o\
              ${LIBKURTZ} ${LIBKURTZBASIC} ${LDLIBS} -o $@

${EXECDIR}mapcfrcrf.x:${COMPILEDIR}mapcfrcrf.o ${LIBKURTZBASIC}
	${LD} ${LDFLAGS} ${COMPILEDIR}mapcfrcrf.o ${LIBKURTZBASIC} ${LDLIBS} -o $@

${EXECDIR}mkcld.x:${COMPILEDIR}mkcld.mn.o ${LIBKURTZ} ${LIBKURTZBASIC}
	${LD} ${LDFLAGS} ${COMPILEDIR}mkcld.mn.o\
              ${LIBKURTZ} ${LIBKURTZBASIC} ${LDLIBS} -o $@

${EXECDIR}mklsf.x:${COMPILEDIR}mklsf.o ${LIBKURTZ} ${LIBKURTZBASIC}
	${LD} ${LDFLAGS} ${COMPILEDIR}mklsf.o ${LIBKURTZ}\
              ${LIBKURTZBASIC} ${LDLIBS} -o $@

${EXECDIR}mkiso.x:${COMPILEDIR}mkiso.o ${LIBKURTZ} ${LIBKURTZBASIC}
	${LD} ${LDFLAGS} ${COMPILEDIR}mkiso.o\
              ${LIBKURTZ} ${LIBKURTZBASIC} ${LDLIBS} -o $@

${EXECDIR}mkrcidx.x:${COMPILEDIR}mkrcidx.o ${LIBS}
	${LD} ${LDFLAGS} ${COMPILEDIR}mkrcidx.o ${LIBS} ${LDLIBS} -o $@

${EXECDIR}mkdna6idx.x:${COMPILEDIR}mkdna6idx.o ${LIBS}
	${LD} ${LDFLAGS} ${COMPILEDIR}mkdna6idx.o ${LIBS} ${LDLIBS} -o $@

# the following programs are mainly for testing purpose

${EXECDIR}mkvram.x:${COMPILEDIR}mkvram.o ${LIBS}
	${LD} ${LDFLAGS} ${COMPILEDIR}mkvram.o ${LIBS} ${LDLIBS} -o $@

${EXECDIR}gccont.x:${COMPILEDIR}gccont.o ${LIBKURTZBASIC}
	${LD} ${LDFLAGS} ${COMPILEDIR}gccont.o ${LIBKURTZBASIC} -o $@

${EXECDIR}mklsf.dbg.x:${COMPILEDIR}mklsf.dbg.o ${LIBSDBG}
	${LD} ${LDFLAGS} ${COMPILEDIR}mklsf.dbg.o ${LIBSDBG} ${LDLIBS} -o $@

${EXECDIR}vseqselect.dbg.x:${COMPILEDIR}vseqselect.dbg.o ${LIBKURTZBASICDBG}
	${LD} ${LDFLAGS} ${COMPILEDIR}vseqselect.dbg.o\
              ${LIBKURTZBASICDBG} ${LDLIBS} -o $@

${EXECDIR}makecld.dbg.x:${COMPILEDIR}makecld.dbg.o ${LIBKURTZBASICDBG}
	${LD} ${LDFLAGS} ${COMPILEDIR}makecld.dbg.o\
              ${LIBKURTZBASICDBG} ${LDLIBS} -o $@

${EXECDIR}mkrcidx.dbg.x:${COMPILEDIR}mkrcidx.dbg.o ${LIBSDBG}
	${LD} ${LDFLAGS} ${COMPILEDIR}mkrcidx.dbg.o ${LIBSDBG} ${LDLIBS} -o $@

${EXECDIR}mkdna6idx.dbg.x:${COMPILEDIR}mkdna6idx.dbg.o ${LIBSDBG}
	${LD} ${LDFLAGS} ${COMPILEDIR}mkdna6idx.dbg.o ${LIBSDBG} ${LDLIBS} -o $@

${COMPILEDIR}besespecial.o:besespecial.c
	${CC} ${CFLAGS} -DSPECIAL -c besespecial.c -o $@

${COMPILEDIR}besespecial.dbg.o:besespecial.c
	${CC} ${CFLAGS} -DSPECIAL -DDEBUG -c besespecial.c -o $@

besespecial.splint:besespecial.c
	splint ${SPLINTFLAGS} -DSPECIAL -DDEBUG besespecial.c
	touch $@

besespecial.c:bese.c
	cp bese.c $@

endian.c:endian.copy
	cp endian.copy $@

Calls.sh:Argtest.lhs
	runhugs -h2M $<
	chmod u+x $@

Mkvcallstab.pm:Argtest.lhs
	runhugs -h2M $<

${LIBMKVTREE}:${MKVTREEOBJ}
	$(AR) ruv $@ ${MKVTREEOBJ}
	$(RANLIB) $@

${LIBMKVTREEDBG}:${MKVTREEDBGOBJ}
	$(AR) ruv $@ ${MKVTREEDBGOBJ}
	$(RANLIB) $@

-include Filegoals.mf

.PHONY:clean
clean:splintclean
	rm -f *.[ox] besespecial.c

.PHONY:cleanpp
cleanpp:
	cleanpp.sh

cflagsstring:
	@echo "${CFLAGS}"

-include $(wildcard ${COMPILEDIR}/*.d)

=== src/Vmatch/Makefile ===
include ../Makedef

#DEFINEVMATCHDB=-DVMATCHDB
#DISTRIBUTEDDFS=-DDISTRIBUTEDDFS
CFLAGS=${DEFINECFLAGS} ${DEFINECPPFLAGS} -I../Vmengine ${DEFINEVMATCHDB} ${DISTRIBUTEDDFS}
SPLINTFLAGS=${DEFINESPLINTFLAGS} -I../Vmengine
#CFLAGS=-DCOUNT
#LIBELECTRICFENCE=-lefence
LDFLAGS=${DEFINELDFLAGS} ${LIBELECTRICFENCE}
LDLIBS=${DEFINELDLIBS}
COMPILEDIR=${COMPILEDIRPREFIX}/Vmatch/
#EXECDIR=${EXECDIRPREFIX}/Vmatch/

ifneq ($(licensemanager),no)
  CFLAGS += -I../../../licensemanager/src \
            -I../../../genometools/src
  LDLIBS = ${CURDIR}/../../../licensemanager/lib/$(BIT)/liblicensemanager.a \
           ${CURDIR}/../../../genometools/lib/libgenometools.a \
           ${DEFINELDLIBS}
else
  CFLAGS += -DNOLICENSEMANAGER
  LDLIBS = ${CURDIR}/../../../genometools/lib/libgenometools.a \
           ${DEFINELDLIBS}
endif

LIBS=${LIBVMATCH}\
     ${LIBVMENGINE}\
     ${LIBMKVTREE}\
     ${LIBKURTZ}\
     ${LIBKURTZBASIC}

LIBSDBG=${LIBVMATCHDBG}\
        ${LIBVMENGINEDBG}\
        ${LIBMKVTREEDBG}\
        ${LIBKURTZDBG}\
        ${LIBKURTZBASICDBG}

PROTOEXPORT=assigndig.pr\
            echomatch.pr\
            detmatch.pr\
            procargs.pr\
            parsevm.pr\
            vmatch.pr\
            chncallparse.pr\
            chainof.pr

.SUFFIXES: .dbg.o .c .o .pr

LIBVMATCHOBJ=\
          ${COMPILEDIR}vmatch.o\
          ${COMPILEDIR}parsevm.o\
          ${COMPILEDIR}optstring.o\
          ${COMPILEDIR}procargs.o\
          ${COMPILEDIR}runself.o\
          ${COMPILEDIR}runquery.o\
          ${COMPILEDIR}mlendistrib.o\
          ${COMPILEDIR}mapdemand.o\
          ${COMPILEDIR}procmatch.o\
          ${COMPILEDIR}queryindex.o\
          ${COMPILEDIR}verifysub.o\
          ${COMPILEDIR}lrseq.o\
          ${COMPILEDIR}echomatch.o\
          ${COMPILEDIR}substpos.o\
          ${COMPILEDIR}markmat.o\
          ${COMPILEDIR}nomatch.o\
          ${COMPILEDIR}showmasked.o\
          ${COMPILEDIR}vmcluster.o\
          ${COMPILEDIR}assigndig.o\
          ${COMPILEDIR}explain.o\
          ${COMPILEDIR}detmatch.o\
          ${COMPILEDIR}opensel.o\
          ${COMPILEDIR}vmdbfunc.o\
          ${COMPILEDIR}parsedbms.o\
          ${COMPILEDIR}chncallparse.o\
          ${COMPILEDIR}chainvm.o\
          ${COMPILEDIR}chainof.o\
          ${COMPILEDIR}initpost.o\
          ${COMPILEDIR}matchlenparm.o\
          ${COMPILEDIR}xmlfunc.o\
          ${COMPILEDIR}vplugin-open.o\
          ${COMPILEDIR}vmotif-start.o\
          ${COMPILEDIR}cpridx-start.o\
          ${COMPILEDIR}parsepp.o\
          ${COMPILEDIR}parsequery.o\
          ${COMPILEDIR}parsedbcl.o\
          ${COMPILEDIR}keepflags.o\
          ${COMPILEDIR}parsemcl.o\
          ${COMPILEDIR}cluedist.o\
          ${COMPILEDIR}matchclust.o\
          ${COMPILEDIR}clpos.o\
          ${COMPILEDIR}allmclust.o\
          ${COMPILEDIR}threadchain.o\
          ${COMPILEDIR}procfinal.o\
          ${COMPILEDIR}mokay.o

LIBVMATCHDBGOBJ=\
          ${COMPILEDIR}vmatch.dbg.o\
          ${COMPILEDIR}parsevm.dbg.o\
          ${COMPILEDIR}optstring.dbg.o\
          ${COMPILEDIR}procargs.dbg.o\
          ${COMPILEDIR}runself.dbg.o\
          ${COMPILEDIR}runquery.dbg.o\
          ${COMPILEDIR}mlendistrib.dbg.o\
          ${COMPILEDIR}mapdemand.dbg.o\
          ${COMPILEDIR}procmatch.dbg.o\
          ${COMPILEDIR}queryindex.dbg.o\
          ${COMPILEDIR}verifysub.dbg.o\
          ${COMPILEDIR}lrseq.dbg.o\
          ${COMPILEDIR}echomatch.dbg.o\
          ${COMPILEDIR}substpos.dbg.o\
          ${COMPILEDIR}markmat.dbg.o\
          ${COMPILEDIR}nomatch.dbg.o\
          ${COMPILEDIR}showmasked.dbg.o\
          ${COMPILEDIR}vmcluster.dbg.o\
          ${COMPILEDIR}assigndig.dbg.o\
          ${COMPILEDIR}explain.dbg.o\
          ${COMPILEDIR}detmatch.dbg.o\
          ${COMPILEDIR}opensel.dbg.o\
          ${COMPILEDIR}vmdbfunc.dbg.o\
          ${COMPILEDIR}parsedbms.dbg.o\
          ${COMPILEDIR}chncallparse.dbg.o\
          ${COMPILEDIR}chainvm.dbg.o\
          ${COMPILEDIR}chainof.dbg.o\
          ${COMPILEDIR}initpost.dbg.o\
          ${COMPILEDIR}matchlenparm.dbg.o\
          ${COMPILEDIR}xmlfunc.dbg.o\
          ${COMPILEDIR}vplugin-open.dbg.o\
          ${COMPILEDIR}vmotif-start.dbg.o\
          ${COMPILEDIR}cpridx-start.dbg.o\
          ${COMPILEDIR}parsepp.dbg.o\
          ${COMPILEDIR}parsequery.dbg.o\
          ${COMPILEDIR}parsedbcl.dbg.o\
          ${COMPILEDIR}keepflags.dbg.o\
          ${COMPILEDIR}parsemcl.dbg.o\
          ${COMPILEDIR}cluedist.dbg.o\
          ${COMPILEDIR}matchclust.dbg.o\
          ${COMPILEDIR}clpos.dbg.o\
          ${COMPILEDIR}allmclust.dbg.o\
          ${COMPILEDIR}threadchain.dbg.o\
          ${COMPILEDIR}procfinal.dbg.o\
          ${COMPILEDIR}mokay.dbg.o

EXPORTPROGS=chain2dim.x\
            matchcluster.x\
            vmatch.x\
            vmatchselect.x

all:mkdircompiledir\
    libs\
    ${EXECDIR}vmatch.x\
    ${EXECDIR}vmatch.dbg.x\
    ${EXECDIR}readm.x\
    ${EXECDIR}readm.dbg.x\
    ${EXECDIR}vmatchselect.x\
    ${EXECDIR}vmatchselect.dbg.x\
    ${EXECDIR}chain2dim.x\
    ${EXECDIR}chain2dim.dbg.x\
    ${EXECDIR}matchcluster.x\
    ${EXECDIR}matchcluster.dbg.x\
    apmcontain.x\
    virtualexp.h

check:
	make SELECT
	env -i MKVTREESMAPDIR=../Mkvtree/TRANS \
        CONFIGGUESS=${CONFIGGUESS} \
	PATH="/usr/bin:/bin:../bin:../bin/${CONFIGGUESS}" \
	LD_LIBRARY_PATH="./SELECT" \
	./Checkall.sh
	env -i ../bin/cleanpp.sh

libs:${LIBVMATCH} ${LIBVMATCHDBG}

bin:${EXPORTPROGS}
	cp ${EXPORTPROGS} ${BINDIRROOT}/`binarypath.sh vmatch.x`

${EXECDIR}vmatch.x:${COMPILEDIR}vmatch.mn.o ${LIBS}
	${LD} ${LDFLAGS} $< ${LIBS} ${LDLIBS} -o $@

${EXECDIR}vmatch.dbg.x:${COMPILEDIR}vmatch.mn.dbg.o ${LIBSDBG}
	${LD} ${LDFLAGS} $< ${LIBSDBG} ${LDLIBS} -o $@

${EXECDIR}vmatchselect.x:${COMPILEDIR}vmatsel.mn.o ${LIBS}
	${LD} ${LDFLAGS} $< ${LIBS} ${LDLIBS} -o $@

${EXECDIR}vmatchselect.dbg.x:${COMPILEDIR}vmatsel.mn.dbg.o ${LIBSDBG}
	${LD} ${LDFLAGS} $< ${LIBSDBG} ${LDLIBS} -o $@

${EXECDIR}readm.x:${COMPILEDIR}readm.mn.o ${LIBS}
	${LD} ${LDFLAGS} $< ${LIBS} ${LDLIBS} -o $@

${EXECDIR}readm.dbg.x:${COMPILEDIR}readm.mn.dbg.o ${LIBSDBG}
	${LD} ${LDFLAGS} $< ${LIBSDBG} ${LDLIBS} -o $@

${EXECDIR}chain2dim.x:${COMPILEDIR}chain2dim.mn.o ${LIBS}
	${LD} ${LDFLAGS} $< ${LIBS} ${LDLIBS} -o $@

${EXECDIR}chain2dim.dbg.x:${COMPILEDIR}chain2dim.mn.dbg.o ${LIBSDBG}
	${LD} ${LDFLAGS} $< ${LIBSDBG} ${LDLIBS} -o $@

${EXECDIR}matchcluster.x:${COMPILEDIR}matchcl.mn.o ${LIBS}
	${LD} ${LDFLAGS} $< ${LIBS} ${LDLIBS} -o $@

${EXECDIR}matchcluster.dbg.x:${COMPILEDIR}matchcl.mn.dbg.o ${LIBSDBG}
	${LD} ${LDFLAGS} $< ${LIBSDBG} ${LDLIBS} -o $@

profiler.x:${COMPILEDIR}profiler.o ${LIBKURTZ}
	${LD} ${LDFLAGS} $< ${LIBKURTZ} ${LDLIBS} -o $@

profiler.dbg.x:${COMPILEDIR}profiler.dbg.o ${LIBKURTZDBG}
	${LD} ${LDFLAGS} $< ${LIBKURTZDBG} ${LDLIBS} -o $@

apmcontain.x:${COMPILEDIR}apmcontain.o ${LIBS}
	${LD} ${LDFLAGS} $< ${LIBS} ${LDLIBS} -o $@

${LIBVMATCH}:${LIBVMATCHOBJ}
	$(AR) ruv $@ ${LIBVMATCHOBJ}
	$(RANLIB) $@

${LIBVMATCHDBG}:${LIBVMATCHDBGOBJ}
	$(AR) ruv $@ ${LIBVMATCHDBGOBJ}
	$(RANLIB) $@

vmotif-demo.o:vmotif-demo.c
	${CC} ${CFLAGS} -fPIC -c $< -o $@

cpridxps-demo.o:cpridxps-demo.c
	${CC} ${CFLAGS} -fPIC -c $< -o $@

vmotif-demo.so:vmotif-demo.o ${LIBKURTZ}
	${CC} ${SHARED} $< ${LIBKURTZ} -o $@

cpridxps-demo.so:cpridxps-demo.o ${LIBKURTZ}
	${CC} ${SHARED} $< ${LIBKURTZ} -o $@


.PHONY:SELECT
SELECT:../Makedef
	${MAKE} -C SELECT -f Makefile.src all
	${MAKE} -C SELECT

Vmcallstab.pm:Argtest.lhs
	runhugs -h2M $<
	chmod u+x $@

.PHONY:clean
clean:splintclean
	rm -f *.[oxa] *.so shit* R100000ACGT R100000acgt tmp[12]
	rm -f query.tmp complete.tmp tmp.match match.tmp test.match .shit
	rm -f tmp tmp2.sort tmp0 tmp0.match .tmp Tmp.index Tmp3 Tmp4 
	rm -f Pattern.tmp
	rm -f .tmp1 .tmp2
	rm -f clout.[0-9]*.[0-9]*.match PAIRS.* MATCH.* SUPERMATCH.*
	rm -rf SELECT/*.so.dSYM/
	${MAKE} -C SELECT clean

.PHONY:cleanpp
cleanpp:
	cleanpp.sh
	rm -f shit.[0-9]*.fna shit.[0-9]*.match shit
	rm -f shit1 shit2 shit2.* shit3
	rm -f tmp.match shitlebrit tmp[12] *.tmp .tmp
	rm -f Tmp.*

virtualexp.h:${PROTOEXPORT}
	@cat ../Copyright > $@
	@echo "/* This file is generated. Do not edit */" >> $@
	@echo "/* It contains the prototypes for some important exported functions. */" >> $@
	@echo "#ifndef VIRTUALEXP_H" >> $@
	@echo "#define VIRTUALEXP_H" >> $@
	@echo "#include \"matchinfo.h\"" >> $@
	@echo "#include \"matchtask.h\"" >> $@
	@echo "#include \"chaindef.h\"" >> $@
	@echo "#include \"xdropdef.h\"" >> $@
	@cat ${PROTOEXPORT} >> $@
	@echo "#endif" >> $@

.PHONY:mkincludes
mkincludes:
	Mkincludes.sh

-include Filegoals.mf

cflagsstring:
	@echo "${CFLAGS} -DALPHABETSIZE=4"

-include $(wildcard ${COMPILEDIR}/*.d)

=== src/Vmengine/Makefile ===
include ../Makedef

.SUFFIXES: .dbg.o .c .o .inc

CFLAGS=${DEFINECFLAGS} ${DEFINECPPFLAGS}
SPLINTFLAGS=${WITHSYSCONF} ${DEFINESPLINTFLAGS} ${DEFINECPPFLAGS}
COMPILEDIR=${COMPILEDIRPREFIX}/Vmengine/
VMENGINEKERN=fcomplete.c\
             fmumself.c\
             fquery.c\
             fself.c\
             fsuper.c\
             ftandem.c

-include Vmatdef1.mf

-include Filelists.mf

LIBVMENGINEOBJ=${LIBOBJECTS}\
               ${VMAT}\
               ${COMPILEDIR}vmatfind-dyn.o\
               ${COMPILEDIR}vmatfind-strm.o

LIBDEBUGVMENGINEOBJ=${LIBDEBUGOBJECTS}\
                    ${VMATDBG}\
                    ${COMPILEDIR}vmatfind-dyn.dbg.o\
                    ${COMPILEDIR}vmatfind-strm.dbg.o

all:mkdircompiledir ${LIBVMENGINE} ${LIBVMENGINEDBG}

${LIBVMENGINE}:${LIBVMENGINEOBJ}
	$(AR) ruv $@ ${LIBVMENGINEOBJ}
	$(RANLIB) $@

-include Filegoals.mf

${LIBVMENGINEDBG}:${LIBDEBUGVMENGINEOBJ}
	$(AR) ruv $@ ${LIBDEBUGVMENGINEOBJ}
	$(RANLIB) $@

.PHONY:clean
clean:splintclean
	rm -f *.[oa] *.dbg.o *.inc *.aux *.dvi *.log

cflagsstring:
	@echo "${CFLAGS}"

libtest:${LIBVMENGINE} ${LIBVMENGINEDBG}
	${MAKE} -C libtest

vmengineexport.h:${VMENGINEKERN}
	cat ${VMENGINEKERN} | skproto > $@

${COMPILEDIR}vmatfind-dyn.o:vmatfind.c ../include/virtualdef.h
	${CC} ${CFLAGS} -DDYNAMICALPHABET -c vmatfind.c -o $@

${COMPILEDIR}vmatfind-strm.o:vmatfind.c ../include/esastream.h
	${CC} ${CFLAGS} -DDYNAMICALPHABET -DESASTREAMACCESS -c vmatfind.c -o $@

${COMPILEDIR}vmatfind-dyn.dbg.o:vmatfind.c ../include/virtualdef.h
	${CC} ${CFLAGS} -DDEBUG -DDYNAMICALPHABET -c vmatfind.c -o $@

${COMPILEDIR}vmatfind-strm.dbg.o:vmatfind.c ../include/esastream.h
	${CC} ${CFLAGS} -DDEBUG -DDYNAMICALPHABET -DESASTREAMACCESS -c vmatfind.c -o $@

vmatfind4.splint:vmatfind.c
	splint ${SPLINTFLAGS} -DDEBUG -DALPHABETSIZE=4 vmatfind.c
	touch vmatfind.c

vmatcount4.splint:vmatcount.c
	splint ${SPLINTFLAGS} -DDEBUG -DALPHABETSIZE=4 vmatcount.c
	touch vmatcount.c

-include $(wildcard ${COMPILEDIR}/*.d)

-include Vmatdef2.mf

=== src/include/Makefile ===
.SUFFIXES:.inc .h

INCFILES=absdef.inc\
         alignment.inc\
         alphadef.inc\
         args.inc\
         arraydef.inc\
         calloc.inc\
         chardef.inc\
         chartype.inc\
         clock.inc\
         clusterdef.inc\
         column.inc\
         compl.inc\
         count.inc\
         debugdef.inc\
         dpbitvec.inc\
         edge.inc\
         errordef.inc\
         experim.inc\
         fdrewr.inc\
         fopen.inc\
         inline.inc\
         intbits.inc\
         iter.inc\
         iubdef.inc\
         logbase.inc\
         longbits.inc\
         longpair.inc\
         match.inc\
         maxfiles.inc\
         megabytes.inc\
         minmax.inc\
         multidef.inc\
         optdesc.inc\
         output.inc\
         overflow.inc\
         processap.inc\
         protodef.inc\
         qsortdef.inc\
         rPair.inc\
         result.inc\
         rsubword.inc\
         scoredef.inc\
         spacedef.inc\
         trie.inc\
         types.inc\
         virtualdef.inc\
         visible.inc\
         xdropdef.inc

TMPHEADERS=libautomata.h\
           matchreport.h\
           skiptree.h\
           textutils.h\
           onlinesimplesearch.h\
           onlinesimplesearch.templ.c\
           onlinesimplesearchundef.h\
           vtreematchdepthfirst.h\
           vtreematchdepthfirst.templ.c\
           vtreematchdepthfirstundef.h\
           agrepexport.h\
           agrepdef.h

all:
	@echo "no default goal"

Cfiles.dvi:$(INCFILES) Cfiles.tex
	latex Cfiles.tex

.PHONY:clean
clean:
	rm -f *.inc Cfiles.dvi Cfiles.aux Cfiles.log
	rm -f ${TMPHEADERS}

%.inc:%.h
	c2lit.x $^ | lit2alt.x -C > $@

=== src/kurtz-basic/Makefile ===
include ../Makedef

.SUFFIXES: .dbg.o .c .o .inc

CFLAGS=${WITHSYSCONF} ${DEFINECFLAGS} ${DEFINECPPFLAGS}
SPLINTFLAGS=${WITHSYSCONF} ${DEFINESPLINTFLAGS} ${DEFINECPPFLAGS}
COMPILEDIR=${COMPILEDIRPREFIX}/kurtz-basic/

ifneq ($(licensemanager),no)
  CFLAGS += -I../../../licensemanager/src \
            -I../../../genometools/src
else
  CFLAGS += -DNOLICENSEMANAGER
endif

-include Filelists.mf

all:release mkdircompiledir prototypes $(LIBKURTZBASIC) $(LIBKURTZBASICDBG)

$(LIBKURTZBASIC):$(LIBOBJECTS)
	$(AR) ruv $@ $(LIBOBJECTS)
	$(RANLIB) $@

-include Filegoals.mf

$(LIBKURTZBASICDBG):$(LIBDEBUGOBJECTS)
	$(AR) ruv $@ $(LIBDEBUGOBJECTS)
	$(RANLIB) $@

release:
	vmrelease.sh VMATCH ${CFLAGS} > ../include/vmrelease.h

chain2dim2.o:chain2dim.c
	${CC} ${CFLAGS} -DREVERSEDIM -c $< -o $@

.PHONY:clean
clean:splintclean
	rm -f *.[oa] *.dbg.o *.inc *.aux *.dvi *.log

cflagsstring:
	@echo "${CFLAGS}"

.PHONY:prototypes
prototypes:${PROTOTYPES}

-include $(wildcard ${COMPILEDIR}/*.d)

=== src/kurtz/Makefile ===
include ../Makedef

.SUFFIXES: .dbg.o .c .o .inc

CFLAGS=${DEFINECFLAGS} ${DEFINECPPFLAGS}
SPLINTFLAGS=${WITHSYSCONF} ${DEFINESPLINTFLAGS} ${DEFINECPPFLAGS}
COMPILEDIR=${COMPILEDIRPREFIX}/kurtz/

ifeq ($(licensemanager),no)
  CFLAGS += -DNOLICENSEMANAGER
endif

-include Filelists.mf

all:mkdircompiledir prototypes $(LIBKURTZ) $(LIBKURTZDBG)

$(LIBKURTZ):$(LIBOBJECTS)
	$(AR) ruv $@ $(LIBOBJECTS)
	$(RANLIB) $@

-include Filegoals.mf

$(LIBKURTZDBG):$(LIBDEBUGOBJECTS)
	$(AR) ruv $@ $(LIBDEBUGOBJECTS)
	$(RANLIB) $@

release:
	vmrelease.sh VMATCH ${CFLAGS} > ../include/vmrelease.h

.PHONY:clean
clean:splintclean
	rm -f *.[oa] *.dbg.o *.inc *.aux *.dvi *.log

cflagsstring:
	@echo "${CFLAGS}"

libtest:$(LIBKURTZ) $(LIBKURTZDBG)
	${MAKE} -C libtest

.PHONY:prototypes
prototypes:${PROTOTYPES}

-include $(wildcard ${COMPILEDIR}/*.d)

=== src/kurtz/libtest/Makefile ===
include ../../Makedef
LD=${CC}
SUBINCLUDEOPT=${subst -I../,-I../../,${INCLUDEOPT}}
CFLAGS=${DEFINECFLAGS} -g ${SUBINCLUDEOPT} -DDEBUG 
CFLAGSWITHOUTDEBUG=${DEFINECFLAGS} -g ${SUBINCLUDEOPT}
LIBS=../${LIBKURTZDBG} ../${LIBKURTZBASICDBG} ${VSTREEBASEDIR}/../../../genometools/lib/libgenometools.a
LIBSDBG=../${LIBKURTZDBG} ../${LIBKURTZBASICDBG} ${VSTREEBASEDIR}/../../../genometools/lib/libgenometools.a
LDFLAGS=${DEFINELDFLAGS} 
LDLIBS=${DEFINELDLIBS}
#-lefence

SPLINTALL:=$(patsubst %.c,%.splint,$(wildcard *.c))

SPLINTFLAGS=-I../../include -DDEBUG -f ../../Splintoptions -casebreak

all:checkEvalue.x\
    readdb.x\
    strmfna.x\
    addmulti.x\
    rmulfast.x\
    checkgalign.x\
    checkxalign.x\
    checkcluster.x\
    rblastm.x\
    codon.x\
    rsymmap.x\
    verifycld.x\
    mygzip.x\
    runredblack.x\
    rundict.x\
    suffixprefix.x\
    spacemanage.x\
    regioncheck.x\
    checklongdist.x\
    checkqsort.x\
    vmatch-mini.x\
    strm-selfcmp.x\
    fillscores.x\
    chainqhits.x\
    checkredrange.x\
    queuetest.x

checkEvalue.x:checkEvalue.o ${LIBSDBG}
	${LD} ${LDFLAGS} checkEvalue.o ${LIBSDBG} ${LDLIBS} -o $@

readdb.x:readdb.o ${LIBS}
	${LD} ${LDFLAGS} readdb.o ${LIBS} ${LDLIBS} -o $@

strmfna.x:strmfna.o ${LIBS}
	${LD} ${LDFLAGS} strmfna.o ${LIBS} ${LDLIBS} -o $@

readdb.o:readdb.c
	${CC} -c ${CFLAGS} readdb.c

suffixprefix.x:suffixprefix.o
	${LD} ${LDFLAGS} suffixprefix.o ${LIBSDBG} ${LDLIBS} -o $@

checkgalign.x:checkgalign.o optsimple.o ${LIBSDBG}
	${LD} ${LDFLAGS} checkgalign.o optsimple.o\
              ${LIBSDBG} ${LDLIBS} -o $@

codon.x:codon.mn.o ${LIBSDBG}
	${LD} ${LDFLAGS} codon.mn.o ${LIBSDBG} ${LDLIBS} -o $@

checkuedist.x:checkuedist.o ${LIBSDBG}
	${LD} ${LDFLAGS} checkuedist.o ${LIBSDBG} ${LDLIBS} -o $@

regioncheck.x:regioncheck.o ${LIBSDBG}
	${LD} ${LDFLAGS} regioncheck.o ${LIBSDBG} ${LDLIBS} -o $@

checkxalign.x:checkxalign.o optsimple.o ${LIBSDBG}
	${LD} ${LDFLAGS} checkxalign.o optsimple.o ${LIBSDBG} ${LDLIBS} -o $@

checkcluster.x:checkcluster.o ${LIBSDBG}
	${LD} ${LDFLAGS} checkcluster.o ${LIBSDBG} ${LDLIBS} -o $@

rsymmap.x:rsymmap.o ${LIBSDBG}
	${LD} ${LDFLAGS} rsymmap.o ${LIBSDBG} ${LDLIBS} -o $@

rmulfast.x:rmulfast.mn.o ${LIBSDBG}
	${LD} ${LDFLAGS} rmulfast.mn.o ${LIBSDBG} ${LDLIBS} -o $@

rblastm.x:rblastm.mn.o ${LIBSDBG}
	${LD} ${LDFLAGS} rblastm.mn.o ${LIBSDBG} ${LDLIBS} -o $@

verifycld.x:verifycld.o ${LIBSDBG}
	${LD} ${LDFLAGS} verifycld.o ${LIBSDBG} ${LDLIBS} -o $@

basename.x:basename.o ${LIBSDBG}
	${LD} ${LDFLAGS} basename.o ${LIBSDBG} ${LIBGEN} ${LDLIBS} -o $@

bitvector.x:bitvector.o ${LIBSDBG}
	${LD} ${LDFLAGS} bitvector.o ${LIBSDBG} ${LIBGEN} ${LDLIBS} -o $@

mygzip.x:mygzip.o ${LIBSDBG}
	${LD} ${LDFLAGS} mygzip.o ${LIBSDBG} ${LDLIBS} -o $@

getEvalue.x:${LIBS} getEvalue.o
	${LD} ${LDFLAGS} getEvalue.o ${LIBS} ${LDLIBS} -o $@

runredblack.x:runredblack.o ${LIBSDBG}
	${LD} ${LDFLAGS} runredblack.o ${LIBSDBG} ${LDLIBS} -o $@

rundict.x:rundict.o ${LIBSDBG}
	${LD} ${LDFLAGS} rundict.o ${LIBSDBG} ${LDLIBS} -o $@

fillscores.x:fillscores.o ${LIBSDBG}
	${LD} ${LDFLAGS} fillscores.o ${LIBSDBG} ${LDLIBS} -o $@

vmatch-mini.x:vmatch-mini.o ../${LIBVMENGINEDBG} ${LIBSDBG}
	${LD} ${LDFLAGS} vmatch-mini.o ../${LIBVMENGINEDBG} ${LIBSDBG} ${LDLIBS} -o $@

strm-selfcmp.x:strm-selfcmp.o ../${LIBVMENGINEDBG} ${LIBSDBG}
	${LD} ${LDFLAGS} strm-selfcmp.o ../${LIBVMENGINEDBG} ${LIBSDBG} ${LDLIBS} -o $@

queuetest.x:queuetest.o ${LIBSDBG}
	${LD} ${LDFLAGS} queuetest.o ${LIBSDBG} ${LDLIBS} -o $@

chainqhits.x:chainqhits.o ${LIBSDBG}
	${LD} ${LDFLAGS} chainqhits.o ${LIBSDBG} ${LDLIBS} -o $@

# We do not need the dynamic space allocation if MULTISEQSTATIC is set
# to check this I have include only those object files from the lib
# which are actually needed. If MULTISEQSTATIC is not set, then add
# ../space.dbg.o

addmulti.x:addmulti.o ${LIBSDBG}
	${LD} ${LDFLAGS} addmulti.o ${LIBSDBG} ${LDLIBS} -o $@

spacemanage.x:spacemanage.c ${LIBS}
	${CC} -c ${CFLAGSWITHOUTDEBUG} spacemanage.c
	${LD} ${LDFLAGS} spacemanage.o ${LIBS} ${LDLIBS} -o $@

checklongdist.x:checklongdist.c ${LIBS}
	${CC} -c ${CFLAGSWITHOUTDEBUG} checklongdist.c
	${LD} ${LDFLAGS} checklongdist.o ${LIBS} ${LDLIBS} -o $@

checkqsort.x:checkqsort.c ${LIBS}
	${CC} -c ${CFLAGSWITHOUTDEBUG} checkqsort.c
	${LD} ${LDFLAGS} checkqsort.o ${LIBS} ${LDLIBS} -o $@

checkredrange.x:checkredrange.c ${LIBS}
	${CC} -c ${CFLAGSWITHOUTDEBUG} checkredrange.c
	${LD} ${LDFLAGS} checkredrange.o ${LIBS} ${LDLIBS} -o $@

-include Filegoals.mf

.PHONY:clean
clean:splintclean
	rm -f *.[ox] shit* at1MB tmp[123]
	cleanpp.sh

cflagsstring:
	@echo "${CFLAGS}"

-include $(wildcard *.d)

=== debian/changelog ===
vmatch (2.3.1+dfsg-9) unstable; urgency=medium

  * Fix clean step of build to enable building twice in a row.
    Closes: #1045627
  * Bump Standards-Version.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 13 Dec 2023 10:12:23 +0100

vmatch (2.3.1+dfsg-8) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * d/watch:
     - Point to Github tags
     - Add filenamemangle
  * Drop debhelper from Build-Depends

  [ Sascha Steinbiss ]
  * Add patch to fix build with GCC 12.
    Addresses: #1013064

 -- Sascha Steinbiss <satta@debian.org>  Sat, 18 Jun 2022 21:50:11 +0200

vmatch (2.3.1+dfsg-7) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on debhelper.
  * watch file standard 4 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 29 Sep 2021 18:51:22 +0200

vmatch (2.3.1+dfsg-6) unstable; urgency=medium

  * Source upload to enable testing transition.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 11 Feb 2020 15:26:49 +0100

vmatch (2.3.1+dfsg-5) unstable; urgency=medium

  * Add patch to set PATH_MAX if not available.
    This adds support for GNU Hurd.
  * Add patch to use 'gt dev skproto' instead of the nonexistent
    'skproto' binary.
  * Add simple autopkgtest to verify that executables (and selection
    functions) work.

 -- Sascha Steinbiss <satta@debian.org>  Sat, 08 Feb 2020 11:24:42 +0100

vmatch (2.3.1+dfsg-4) unstable; urgency=medium

  * Pass CFLAGS and friends to SELECT shared object building.

 -- Sascha Steinbiss <satta@debian.org>  Thu, 23 Jan 2020 22:14:29 +0100

vmatch (2.3.1+dfsg-3) unstable; urgency=medium

  * Fix check for SOURCE_DATE_EPOCH.

 -- Sascha Steinbiss <satta@debian.org>  Wed, 22 Jan 2020 06:28:24 +0100

vmatch (2.3.1+dfsg-2) unstable; urgency=medium

  * Source upload to allow for testing migration.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 21 Jan 2020 22:42:18 +0100

vmatch (2.3.1+dfsg-1) unstable; urgency=medium

  * Sync packaged version with upstream tags.
  * Hopefully fix building on various archs by removing -m32/-m64 handling.
  * Add and extend reproducibility patch. Thanks to Chris Lamb.
  * Bump Standards-Version.

 -- Sascha Steinbiss <satta@debian.org>  Tue, 21 Jan 2020 21:48:45 +0100

vmatch (2.3.0+git20200101.0.b1bd228+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #947954)

 -- Sascha Steinbiss <satta@debian.org>  Fri, 03 Jan 2020 10:10:26 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                zlib1g-dev,
                libbz2-dev,
                asciidoctor
-Standards-Version: 4.7.2
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/vmatch
 Vcs-Git: https://salsa.debian.org/med-team/vmatch.git
 Homepage: http://www.vmatch.de

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1
export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PATH:=$(PATH):$(CURDIR)/src/bin
export WORKVSTREESRC=$(CURDIR)/src

%:
	dh $@

override_dh_auto_clean:
	cd src && make cleanup
	test ! -e src/Vmatch/SELECT/Shareddef || (cd src/Vmatch/SELECT && make clean)
	test ! -e src/Makedef || (cd src/Mkvtree && make clean)
	find $(CURDIR) -name "*.x" -delete
	find $(CURDIR) -name "*.d" -delete
	find $(CURDIR) -name "*.so" -delete
	rm -rf debian/man \
	       src/Makedef-debian \
		   src/dist \
		   src/Vmatch/SELECT/Shareddef \
		   src/include/vmrelease.h \
		   src/Makedef \
		   src/Vmatch/virtualexp.h

override_dh_auto_build:
	cp debian/Makedef-debian src/Makedef-debian
	cd src && mklink.sh debian
	cd src && make licensemanager=no $*

override_dh_auto_install:
	cd src && make licensemanager=no dist
	dh_auto_install

override_dh_installman:
	mkdir -p $(CURDIR)/debian/man
	asciidoctor -a docdate='' -b manpage $(CURDIR)/debian/mansrc/*.adoc
	mv $(CURDIR)/debian/mansrc/*.? $(CURDIR)/debian/man
	dh_installman --

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/genometools/vstree/tags .*/v?(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
